$package("util")
util.Accredit = {};
util.Accredit.ModeFlag = {
	ACCESSIBLE_FLAG:1,
	CREATEABLE_FLAG:2,
	UPDATEABLE_FLAG:4,
	REMOVEABLE_FLAG:8
};
$apply(util.Accredit,{
	canRead:function(value){
		var flag = util.Accredit.ModeFlag.ACCESSIBLE_FLAG;
		return (value & flag) == flag;
	},
	canCreate:function(value){
		var flag = util.Accredit.ModeFlag.CREATEABLE_FLAG;
		return (value & flag) == flag;
	},
	canUpdate:function(value){
		var flag = util.Accredit.ModeFlag.UPDATEABLE_FLAG;
		return (value & flag) == flag;
	},
	canRemove:function(value){
		var flag = util.Accredit.ModeFlag.REMOVEABLE_FLAG;
		return (value & flag) == flag;
	}
});
$package("util.dictionary")
$import("util.widgets.MyCombox", "util.dictionary.DictionaryLoader",
		"util.dictionary.HttpProxy")

util.dictionary.SimpleDicFactory = {
	getUrl : util.dictionary.DictionaryLoader.getUrl,
	getStore : function(dic) {
		var url = this.getUrl(dic);
		var proxy = new util.dictionary.HttpProxy({ // new Ext.data.HttpProxy
			method : "GET", // make cache,upper
			url : url
		});
		var store = new Ext.data.JsonStore({
					proxy : proxy,
					totalProperty : 'result',
					root : 'items',
					fields : dic.fields
							|| ['key', 'text', dic.searchField || "mCode"]
				})
		return store
	},
	getCombox : function(dic) {
		var combox = new util.widgets.MyCombox({
					store : this.getStore(dic),
					valueField : "key",
					displayField : "text",
					searchField : dic.searchField || "mCode",
					editable : (dic.editable == 'false') ? false : true,
					minChars : (!dic.remote ? 1 : 2),
					queryDelay : 10,
					selectOnFocus : true,
					triggerAction : dic.remote ? "query" : "all",
					emptyText : dic.emptyText || '请选择',
					pageSize : dic.pageSize,
					width : dic.width || 200,
					value : dic.defaultValue || dic.value,
					forceSelection : dic.forceSelection || false,
					customInput : dic.customInput || false // 允许用户输入下拉框以外的值
				})
		return combox
	},
	createDic : function(dic) {
		var combox = this.getCombox(dic)
		if (!dic.remote) {
			combox.mode = 'local';
			combox.store.filter = function(property, value, anyMatch,
					caseSensitive, exactMatch) {
				var fn;
				// we can accept an array of filter objects, or a single filter
				// object - normalize them here
				if (Ext.isObject(property)) {
					property = [property];
				}

				if (Ext.isArray(property)) {
					var filters = [];

					// normalize the filters passed into an array of filter
					// functions
					for (var i = 0, j = property.length; i < j; i++) {
						var filter = property[i], func = filter.fn, scope = filter.scope
								|| this;

						// if we weren't given a filter function, construct one
						// now
						if (!Ext.isFunction(func)) {
							func = this.createFilterFn(filter.property,
									filter.value, filter.anyMatch,
									filter.caseSensitive, filter.exactMatch);
						}

						filters.push({
									fn : func,
									scope : scope
								});
					}

					fn = this.createMultipleFilterFn(filters);
				} else {
					// classic single property filter
					// 判断输入是否是汉字
					if (!(/[\u4e00-\u9fa5]+/).test(value)) {
						property = dic.searchField;
					}
					fn = this.createFilterFn(property, value, anyMatch,
							caseSensitive, exactMatch);
				}

				return fn ? this.filterBy(fn) : this.clearFilter();
			};
			// combox.minChars = 99;
			if (dic.autoLoad || dic.defaultIndex) {
				// 默认选中第几行
				var defaultIndex = dic.defaultIndex;
				if (defaultIndex) {
					combox.store.on("load", function() {
								if (this.getCount() == 0)
									return;
								if (defaultIndex) {
									if (isNaN(defaultIndex)
											|| this.getCount() <= defaultIndex)
										defaultIndex = 0;
									combox.setValue(this.getAt(defaultIndex)
											.get('key'));
									defaultIndex = null;
								}
							})
				}
				combox.store.load()
			}
		}
		return combox;
	},
	createLocalStore : function(dic) {
		var store = new Ext.data.JsonStore({
					fields : ['key', 'text'],
					data : dic.data || []
				})
		return store
	},
	createLocalDic : function(dic) {
		var comb = new util.widgets.MyCombox({
					store : this.createLocalStore(dic),
					valueField : "key",
					displayField : "text",
					mode : "local",
					triggerAction : "all",
					emptyText : dic.emptyText || "请选择",
					value : dic.value,
					selectOnFocus : dic.selectOnFocus || false,
					editable : dic.editable || true,
					width : dic.width || 120
				});
		return comb
	}
}
$package("util.widgets")

util.widgets.MyPagingToolbar = function(cfg) {
	util.widgets.MyPagingToolbar.superclass.constructor.apply(this, [cfg])
	this.addEvents({
		"beforePageChange" : true,
		"pageChange" : true
	})
}
Ext.extend(util.widgets.MyPagingToolbar, Ext.PagingToolbar, {
	initComponent : function() {
		var pages = [5,10,25,50,100,300,500];
		data = [];
		for(var i=0;i<pages.length;i++){
			data.push([pages[i],'每页'+pages[i]+'条'])
		}
		var store = new Ext.data.SimpleStore({
			fields : ['value', 'text'],
			data : data
		});
		if (this.requestData.pageSize) {
			this.pageSize = this.requestData.pageSize
		}
		var combox = new Ext.form.ComboBox({
			store : store,
			valueField : "value",
			displayField : "text",
			editable : false,
			selectOnFocus : true,
			triggerAction : 'all',
			mode : 'local',
			emptyText : '',
			width : 80,
			value : this.pageSize
		})
		combox.on("select", function(combo, record, index) {
			debugger
			var pageSize = parseInt(record.data.value)
			var total = this.store.getTotalCount()
			// 当原页面展示值 > 总数 且 选择的展示值 > 原页面展示值时。不改变页面选择
			if (this.pageSize >= total && pageSize > this.pageSize) {
				combox.setValue(this.pageSize)
				return
			}
			this.pageSize = pageSize;
			this.doLoad(0);
		}, this)
		this.items = (["-", combox]).concat(this.items || [])
		util.widgets.MyPagingToolbar.superclass.initComponent.call(this);
	},
	updateInfo : function(n) {
		if (this.displayItem) {
			var count = this.store.getCount();
			var end = this.cursor + count
			var total = this.store.getTotalCount()
			if(n){
			   total = n
			}
			if (end > total) {
				end = total
			}
			var msg = count == 0 ? this.emptyMsg : String.format(
					this.displayMsg, this.cursor + 1, end, total);
			this.displayItem.setText(msg);
		}
	},
	doLoad : function(start) {
		var pageSize = this.pageSize
		var pageNo = Math.ceil((start + pageSize) / pageSize)
		this.requestData.pageSize = pageSize
		this.requestData.pageNo = pageNo
		var o = {}, pn = this.getParams();
		o[pn.start] = start;
		o[pn.limit] = pageSize;
		this.store.load({
			params : o
		});
	}
})

$package("util.widgets")

util.widgets.MyRowExpander = function(config){
    Ext.apply(this, config);

    this.addEvents({
        beforeexpand : true,
        expand: true,
        beforecollapse: true,
        collapse: true
    });

    util.widgets.MyRowExpander.superclass.constructor.call(this);

    if(this.tpl){
        if(typeof this.tpl == 'string'){
            this.tpl = new Ext.Template(this.tpl);
        }
        this.tpl.compile();
    }

    this.state = {};
    this.bodyContent = {};
};

Ext.extend(util.widgets.MyRowExpander, Ext.util.Observable, {
    header: "",
    width: 20,
    sortable: false,
    fixed:true,
    dataIndex: '',
    id: 'expander',
    lazyRender : true,
    enableCaching: true,

    getRowClass : function(record, rowIndex, p, ds){
        p.cols = p.cols-1;
        var content = this.bodyContent[record.id];
        if(!content && !this.lazyRender){
            content = this.getBodyContent(record, rowIndex);
        }
        if(content){
            p.body = content;
        }
        return this.state[record.id] ? 'x-grid3-row-expanded' : 'x-grid3-row-collapsed';
    },

    init : function(grid){
        this.grid = grid;

        var view = grid.getView();
        view.getRowClass = this.getRowClass.createDelegate(this);

        view.enableRowBody = true;

        grid.on('render', function(){
            view.mainBody.on('mousedown', this.onMouseDown, this);
        }, this);
    },

    getBodyContent : function(record, index){
        if(!this.enableCaching){
            return this.tpl.apply(record.data);
        }
        var content = this.bodyContent[record.id];
        if(!content){
            content = this.tpl.apply(record.data);
            this.bodyContent[record.id] = content;
        }
        return content;
    },

    onMouseDown : function(e, t){
        if(t.className == 'x-grid3-row-expander'){
            e.stopEvent();
            var row = e.getTarget('.x-grid3-row');
            this.toggleRow(row);
        }
    },

    renderer : function(v, p, record){
        p.cellAttr = 'rowspan="2"';
        return '<div class="x-grid3-row-expander">&#160;</div>';
    },

    beforeExpand : function(record, body, rowIndex){
        if(this.fireEvent('beforeexpand', this, record, body, rowIndex) !== false){
            if(this.tpl && this.lazyRender){
                body.innerHTML = this.getBodyContent(record, rowIndex);
            }
            return true;
        }else{
            return false;
        }
    },

    toggleRow : function(row){
        if(typeof row == 'number'){
            row = this.grid.view.getRow(row);
        }
        this[Ext.fly(row).hasClass('x-grid3-row-collapsed') ? 'expandRow' : 'collapseRow'](row);
    },

    expandRow : function(row){
        if(typeof row == 'number'){
            row = this.grid.view.getRow(row);
        }
        var record = this.grid.store.getAt(row.rowIndex);
        var body = Ext.DomQuery.selectNode('tr:nth(2) div.x-grid3-row-body', row);
        if(this.beforeExpand(record, body, row.rowIndex)){
            this.state[record.id] = true;
            Ext.fly(row).replaceClass('x-grid3-row-collapsed', 'x-grid3-row-expanded');
            this.fireEvent('expand', this, record, body, row.rowIndex);
        }
    },

    collapseRow : function(row){
        if(typeof row == 'number'){
            row = this.grid.view.getRow(row);
        }
        var record = this.grid.store.getAt(row.rowIndex);
        var body = Ext.fly(row).child('tr:nth(1) div.x-grid3-row-body', true);
        if(this.fireEvent('beforcollapse', this, record, body, row.rowIndex) !== false){
            this.state[record.id] = false;
            Ext.fly(row).replaceClass('x-grid3-row-expanded', 'x-grid3-row-collapsed');
            this.fireEvent('collapse', this, record, body, row.rowIndex);
        }
    }
});

$package("util.widgets")

util.widgets.MyRadioGroup = Ext.extend(Ext.form.RadioGroup,  {
   blankText : '必须在该组中选择一项',
   getName:function(){
   		return this.name;
   },
   setValue:function(v){
   		var value = typeof v == "object" ? v.key : v
   		   		
		if(!this.items.getCount){
			for(var i = 0; i < this.items.length; i ++){
				var item = this.items[i]
				if(item.inputValue == value){
					item.checked = true
				}
				else{
					item.checked = false
				}
			}
			return;
		}
   	
		this.items.each(function(item){
            if(item.inputValue == value){
            	item.setValue(true)
            }
            else{
            	item.setValue(false)
            }
        })		
   },
   getValue:function(){
	   	var items = this.items
	   	if(!items.getCount){
	   		return null;
	   	}
	   	var n = items.getCount();
	   	for(var i = 0; i < n; i ++){
	   			var item = items.item(i)
	   			if(item.getValue())
	   				return item.inputValue;
	   		}
   },
   initValue : function(){
	    // reference to original value for reset
	    this.originalValue = this.getValue();
	   	if(this.value && this.value !== undefined){
	            this.setValue(this.value);
	    }

    }   
});   
Ext.reg('MyRadioGroup', util.widgets.MyRadioGroup); 
$package("app.modules.list")
$import("app.desktop.Module","util.rmi.loadXML","app.modules.list.LodopFuncs","util.widgets.SpinnerField")

app.modules.list.PrintWin = function(cfg) {
	app.modules.list.PrintWin.superclass.constructor.apply(this, [cfg])
}
Ext.extend(app.modules.list.PrintWin, app.desktop.Module, {
	initPanel:function(){
		var printerCombox=this.getPrinters()
		printerCombox.on("select",this.getPageSize,this)	
		var printConfig = new Ext.FormPanel({
			frame: true,
			defaults: {width: '95%'},
			shadow:true,
	        labelWidth: 75, 
	        bodyStyle:'padding:2px 20px 0 0',
	        autoScroll:true,
	        labelAlign:'top',
	        name:"当前打印参数",
	        title:"当前打印参数",
	        items: [{
	            layout:'column',
	            items:[{
	                columnWidth:.5,
	                layout: 'form',
	                defaultType: 'textfield',
	                items:[ printerCombox,
	                		this.getCombox({	
								fieldLabel: '纸张方向',
					            name: 'Orient',
					            anchor:'95%'
							},[['1','纵向'],['2','横向']]),
							{
								xtype : "numberfield",
								name:"top",
								fieldLabel : "上边距(默认单位:cm)",
								anchor:'95%'
							},
							new util.widgets.MyRadioGroup({
					            value:'whole',
					            name:"pages",
					            anchor:'95%',
					            fieldLabel: '打印内容',
					            items: [
					                {boxLabel: '全部页', name: 'gird-print-1',inputValue:'whole'},
					                {boxLabel: '当前页', name: 'gird-print-1',inputValue:'single'}
					            ]   	
							})
	                ]
	            },{
	                columnWidth:.5,
	                layout: 'form',
	                defaultType: 'textfield',
	                items:[this.getCombox({
							fieldLabel: '打印机支持纸张大小',
				            name: 'pageSize',
				            anchor:'95%'
						}),{
				            	xtype: 'spinnerfield',
				            	fieldLabel: '打印份数',
				            	 name: 'copies',
				            	minValue: 0,
				            	maxValue: 100,
				            	allowDecimals: true,
				            	decimalPrecision: 1,
				            	incrementValue: 1,
				            	accelerate: true ,
				            	allowDecimals:false,
							    anchor:'95%'
				            },{
								xtype : "numberfield",
								name:"left",
								fieldLabel : "左边距(默认单位:cm)",
								anchor:'95%'
							}/*,
			                {
								xtype : "numberfield",
								name:"but",
								fieldLabel : "下边距(默认单位:px)",
								anchor:'95%'
							},
							{
								xtype : "numberfield",
								name:"right",
								fieldLabel : "右边距(默认单位:px)",
								anchor:'95%'
							}*/
			         ]
	            }]
	        }]
		})
		this.printConfig=printConfig
		this.loadPrintSet()
		return printConfig
	},
	printPreview:function(btn){
		var fields=this.getFields();
		var page = fields.pages.getValue()
		var type = 0
		if(btn && btn.iconCls){
			if(btn.iconCls=="print"||btn.iconCls=="print-preview"){
				type = 1
			}else if(btn.iconCls=="doc"){
				type = 2
			}else if(btn.iconCls=="excel"){
				type = 3
			}
		}
		var cm = this.cm
		var cos = cm.getColumnsBy(function(c){
  			return !c.hidden;
		})
		var cname = []
		for(var i=0;i<cos.length;i++){
			cname.push(cos[i].dataIndex)
		}
		var printConfig = {
			title:this.title,
			page:page,
			requestData:this.requestData,
			cname:cname
		}
		this.fixPrintConfig(printConfig);
		var url ="list.print?type="+type+"&config="+encodeURI(encodeURI(Ext.encode(printConfig)))
		if(btn.iconCls=="print"||btn.iconCls=="print-preview"){
			//将打印设置以，隔开存cookie，顺序1.打印机 2.纸张大小 3.方向 4.上边距 5.左边距 
			var printSet=fields.printer.getValue()+","+fields.pageSize.getValue()+","+fields.Orient.getValue()+","+
			fields.top.getValue()+","+fields.left.getValue();
			var date = new Date()
		    date.setTime(date.getTime() + 3650*24*3600*1000)
		    date.toGMTString()
			Ext.util.Cookies.set('print'+this.title,printSet,date,"")
			var LODOP=getLodop();
			LODOP.PRINT_INIT("打印控件");
			LODOP.SET_PRINT_PAGESIZE(fields.Orient.getValue(),"","",fields.pageSize.getValue());
			LODOP.ADD_PRINT_HTM(fields.top.getValue()==""?5:fields.top.getValue()+"cm",fields.left.getValue()==""?5:fields.left.getValue()+"cm","100%","100%",util.rmi.loadXML({url:url,httpMethod:"get"}));
			if (fields.copies.getValue()!=""){
				LODOP.SET_PRINT_COPIES(fields.copies.getValue())
			}
			if(btn.iconCls=="print"){
				LODOP.SET_PRINTER_INDEXA(fields.printer.getValue())
				LODOP.PRINT()
			}else{
				if(fields.printer.getValue()!=""){
					LODOP.SET_PRINTER_INDEXA(fields.printer.getValue())
				}
				//LODOP.PREVIEW()
				LODOP.PRINT()
			}
		}else{
			var printWin = window.open(url,"","height="+(screen.height-100)+", width="+(screen.width-10)+", top=0, left=0, toolbar=no, menubar=yes, scrollbars=yes, resizable=yes,location=no, status=no")
			return printWin
		}
	},
	fixPrintConfig:function(cfg){	
	},
	getWin:function(){
		var win = this.win
		if(!win){
			win = new Ext.Window({
				title:"打印设置",
				width:450,
				autoHeight:true,
				constrain : true,
				closeAction:"hide",
				modal :true, 
				items:this.initPanel(),
				tbar:[{
					text:"直接打印",
					iconCls:"print",
					handler:this.printPreview,
					scope:this
				},{
					text:"打印预览",
					iconCls:"print-preview",
					handler:this.printPreview,
					scope:this
				},{
					text:"WORD",
					iconCls:"doc",
					handler:this.printPreview,
					scope:this
				},{
					text:"PDF",
					iconCls:"pdf",
					handler:this.printPreview,
					scope:this
				},{
					text:"EXCEL",
					iconCls:"excel",
					handler:this.printPreview,
					scope:this
				},{
					text:"关闭",
					iconCls:"common_cancel",
					handler:function(){
						this.getWin().hide();
					},
					scope:this
				}]
			})
			var renderToEl = this.getRenderToEl()
			if (renderToEl) {
				win.render(renderToEl)
			}
			win.on("add", function() {
				this.win.doLayout()
			}, this)
			this.win = win
		}
		return win
	},
	getPrinters:function(){
		var LODOP=getLodop()
		var datas=[]
		for(var i=0;i<LODOP.GET_PRINTER_COUNT();i++){
			var data=[]
			data.push(i)
			data.push(LODOP.GET_PRINTER_NAME(i))
			datas.push(data)
		}
		return this.getCombox({
			fieldLabel: '选择打印机',
            name: 'printer',
            anchor:'95%',
            minListWidth:280
		},datas)
	},
	getPageSize:function(f){
		var LODOP=getLodop()
		var datas=[]
		var strPageSizeList=LODOP.GET_PAGESIZES_LIST(f.getValue(),"%");
		var Options=new Array(); 
		var Options=strPageSizeList.split("%");
		for (var i=0;i<Options.length;i++){
			var data=[]
			data.push(Options[i])
			data.push(Options[i])
			datas.push(data)
	   	}
	   	var field=this.getFields()
	   	field.pageSize.clearValue()
	   	field.pageSize.store.loadData(datas)
	},
	getCombox:function(cfg,data){
		var combox = new Ext.form.ComboBox({
    		typeAhead: true,
    		triggerAction: 'all',
  			forceSelection: true,  
    		lazyRender:true,
    		mode: 'local',
    		emptyText:'请选择...',
    		anchor:'95%',
    		store: new Ext.data.ArrayStore({
        		fields: [
            		'key',
            		'value'
        		],
        		data: []
    		}),
    		valueField: 'key',
    		displayField: 'value'
		});
		Ext.apply(combox,cfg)
		if(data){
			combox.store.loadData(data)
		}
		return combox;
	},
	getFields:function(){
		var fields = this.fields
		if(!fields){
			var items = this.printConfig.items.item(0).items
			var n = items.getCount()
			var fields = {}
			for(var i = 0; i < n; i ++){
				var items1 = items.get(i).items
				var n1= items1.getCount()
				for(var j = 0; j < n1; j ++){
					var f = items1.get(j)
					if(f.name)
						fields[f.name] = f
				}
			}
			this.fields= fields
		}
		return fields
	},
	loadPrintSet:function(){
		var printSet=Ext.util.Cookies.get('print'+this.title);
		var fields=this.getFields();
		this.getPageSize(fields.printer)
		if(printSet!=null){
			var p=printSet.split(",")
			fields.printer.setValue(p[0])
			fields.pageSize.setValue(p[1])
			fields.Orient.setValue(p[2])
			fields.top.setValue(p[3])
			fields.left.setValue(p[4])
			fields.copies.setValue(1)
			
		}else{
			fields.top.setValue(0.15)
			fields.left.setValue(0.15)
			fields.printer.setValue(fields.printer.store.getAt(0).data.key)
			fields.pageSize.setValue("A4")
			fields.Orient.setValue(1)
			fields.copies.setValue(1)
		}
	}
})
$package("util.widgets")

$styleSheet("util.widgets.DateTimeField.css.DateTimePicker")

util.widgets.Adapter = function(component, config){
    util.widgets.Adapter.superclass.constructor.call(this, config);
    this.component = component;
};
Ext.extend(util.widgets.Adapter, Ext.menu.BaseItem, {
    // private
    canActivate : true,

    // private
   onRender : function(container, position){
        this.component.render(container);
        this.el = this.component.getEl();
        if(this.ownerCt && this.ownerCt instanceof Ext.menu.Menu){
            this.parentMenu = this.ownerCt;
        }
    },
	
    // private
    activate : function(){
        if(this.disabled){
            return false;
        }
        this.component.focus();
        this.fireEvent("activate", this);
        return true;
    },

    // private
    deactivate : function(){
        this.fireEvent("deactivate", this);
    },

    // private
    disable : function(){
        this.component.disable();
        util.widgets.Adapter.superclass.disable.call(this);
    },

    // private
    enable : function(){
        this.component.enable();
        util.widgets.Adapter.superclass.enable.call(this);
    }

});

util.widgets.DateTimeField = Ext.extend(Ext.form.DateField, {
	
	timeFields:'auto',
	
	// private
	availableTimeFields:['H','h','G','g','i','s'],
	
	// private
	formatMap:{g:'h',G:'H'},
	
	// private
	timeFieldHandlers : null,
	
	initComponent : function(){
		if(Ext.isString(this.minValue)){
            this.minValue = this.safeParse(this.minValue, 'Y-m-d H:i:s');
        }
        if(Ext.isString(this.maxValue)){
            this.maxValue = this.safeParse(this.maxValue, 'Y-m-d H:i:s');
        }
		util.widgets.DateTimeField.superclass.initComponent.call(this);
		
		// Auto detect trigger from format
		if (!this.timeFields || this.timeFields=='auto') {
			this.timeFields = '';
			for(i in this.availableTimeFields){
				var timeField = this.availableTimeFields[i];
				if (this.format.indexOf(timeField)>=0) {
					this.timeFields += timeField;
				}
			}			
		};
		
		// Add date trigger
		var cn = [{tag: "img", src: Ext.BLANK_IMAGE_URL, cls: "x-form-trigger x-form-date-trigger"}];
		
		// Add time triggers
		var validation = this.availableTimeFields.join("");
		for(var i=0;i<this.timeFields.length;i++) {
			var timeField = this.timeFields.charAt(i);
			if (validation.indexOf(timeField)<0) {
				continue;
			}
			timeField = this.formatMap[timeField] || timeField;
			cn.push({tag: "img", src: Ext.BLANK_IMAGE_URL, cls: "x-form-trigger x-form-time-"+timeField+"-trigger"});
		}
		this.triggerConfig = {tag:'span', cls:'x-form-dateTime-triggers',cn:cn};
    },
    
    onResize : function(w, h){
    	Ext.form.TriggerField.superclass.onResize.call(this, w, h);
    	var tw = this.trigger.getWidth() || (17 * (this.timeFields.length+1));
		if(Ext.isNumber(w)){
            this.el.setWidth(w - tw);
        }
        this.wrap.setWidth(this.el.getWidth() + tw);
    },

    getTrigger : function(index){
        return this.triggers[index];
    },
    
    setMinValue : function(dt){
        this.minValue = (typeof dt == "string" ? this.safeParse(dt, 'Y-m-d H:i:s') : dt);
        if(this.menu){
            this.menu.picker.setMinDate(new Date(this.minValue.getTime()));
        }
    },

    setMaxValue : function(dt){
        this.maxValue = (typeof dt == "string" ? this.safeParse(dt, 'Y-m-d H:i:s') : dt);
        if(this.menu){
            this.menu.picker.setMaxDate(new Date(this.maxValue.getTime()));
        }
    },
    
    onTriggerClick : function(){
        if(this.disabled){
            return;
        }
        if(this.menu == null){
            this.menu = new Ext.menu.DateMenu();
        }
        Ext.apply(this.menu.picker,  {
            minDate : this.minValue ? new Date(this.minValue.getTime()) : this.minValue,
            maxDate : this.maxValue ? new Date(this.maxValue.getTime()) : this.maxValue,
            disabledDatesRE : this.ddMatch,
            disabledDatesText : this.disabledDatesText,
            disabledDays : this.disabledDays,
            disabledDaysText : this.disabledDaysText,
            format : this.format,
            showToday : this.showToday,
			todayIsNow : true,
            minText : String.format(this.minText, this.formatDate(this.minValue)),
            maxText : String.format(this.maxText, this.formatDate(this.maxValue))
        });
        this.menu.on(Ext.apply({}, this.menuListeners, {
            scope:this
        }));
        this.menu.picker.setValue(this.getValue() || new Date());
        this.menu.show(this.el, "tl-bl?");
    },

    initTrigger : function(){
        var ts = this.trigger.select('.x-form-trigger', true);
        this.wrap.setStyle('overflow', 'hidden');
        this.timeFieldHandlers = new Array();
        var triggerField = this;        
        ts.each(function(t, all, index){
            t.hide = function(){
                var w = triggerField.wrap.getWidth();
                this.dom.style.display = 'none';
                triggerField.el.setWidth(w-triggerField.trigger.getWidth());
            };
            t.show = function(){
                var w = triggerField.wrap.getWidth();
                this.dom.style.display = '';
                triggerField.el.setWidth(w-triggerField.trigger.getWidth());
            };
            if (index>0) {
            	var timeField = triggerField.timeFields.charAt(index-1);
            	timeField = this.formatMap[timeField] || timeField;
            	var handler = new util.widgets.TimeFieldHandler({parent:this,timeField:timeField});
            	t.on("click", handler.onTriggerClick, handler, {preventDefault:true});
            	triggerField.timeFieldHandlers.push(handler);
            } else {
            	t.on("click", this.onTriggerClick, this, {preventDefault:true});
            }
            t.addClassOnOver('x-form-trigger-over');
            t.addClassOnClick('x-form-trigger-click');
        }, this);
        this.triggers = ts.elements;        
    },
    
    onDestroy : function(){
    	if (this.timeFieldHandlers) {
	        for(var i=this.timeFieldHandlers.length-1;i>=0;i--) {
	        	var handler = this.timeFieldHandlers[i];
	        	handler.destroy();
	        	this.timeFieldHandlers[i]=null;
	        	delete handler;
	        }
	        this.timeFieldHandlers=null;
    	}
        util.widgets.DateTimeField.superclass.onDestroy.call(this);
    },
	
	// private
	validateBlur : function(){
		if (!util.widgets.DateTimeField.superclass.validateBlur.call(this)){
			return false;
		}
		for(var i=this.timeFieldHandlers.length-1;i>=0;i--) {
			if (!this.timeFieldHandlers[i].validateBlur()) {
				return false;
			}
		}
        return true;
    },

 // private
    menuListeners : {
        select: function(m, d){
	    	var v = new Date(d.getTime());
			if (this.getValue()) {
				d.setHours(this.getValue().getHours());
				d.setSeconds(this.getValue().getSeconds());
				d.setMinutes(this.getValue().getMinutes());    			
			}
    		this.setValue(d);
        },
        show : function(){ // retain focus styling
            this.onFocus();
        },
        hide : function(){
            this.focus.defer(10, this);
            var ml = this.menuListeners;
            this.menu.un("select", ml.select,  this);
            this.menu.un("show", ml.show,  this);
            this.menu.un("hide", ml.hide,  this);
        }
    },
    getErrors: function(value) {
        var errors = Ext.form.DateField.superclass.getErrors.apply(this, arguments);

        value = this.formatDate(value || this.processValue(this.getRawValue()));

        if (value.length < 1) { // if it's blank and textfield didn't flag it then it's valid
             return errors;
        }

        var svalue = value;
        value = this.parseDate(value);
        if (!value) {
            errors.push(String.format(this.invalidText, svalue, this.format));
            return errors;
        }

        var time = value.getTime();
        if (this.minValue && time < this.minValue.getTime()) {
            errors.push(String.format(this.minText, this.formatDate(this.minValue)));
        }

        if (this.maxValue && time > this.maxValue.getTime()) {
            errors.push(String.format(this.maxText, this.formatDate(this.maxValue)));
        }

        if (this.disabledDays) {
            var day = value.getDay();

            for(var i = 0; i < this.disabledDays.length; i++) {
                if (day === this.disabledDays[i]) {
                    errors.push(this.disabledDaysText);
                    break;
                }
            }
        }

        var fvalue = this.formatDate(value);
        if (this.disabledDatesRE && this.disabledDatesRE.test(fvalue)) {
            errors.push(String.format(this.disabledDatesText, fvalue));
        }

        return errors;
    }
});
Ext.reg('datetimefield', util.widgets.DateTimeField);

// private
util.widgets.TimeFieldHandler = function (config) {
	Ext.apply(this,config);	
}
Ext.extend(util.widgets.TimeFieldHandler, Ext.util.Observable,{
	parent : null,
	timeField:null,
	menu : null,
	
	onTriggerClick : function(){
		if(this.parent.disabled){
            return;
        }
        if(this.menu == null){
            this.menu = new util.widgets.TimeFieldMenu({timeField:this.timeField});
        }
        Ext.apply(this.menu.picker,  {
            minDate : this.parent.minValue,
            maxDate : this.parent.maxValue,
            minText : String.format(this.parent.minText, this.parent.formatDate(this.parent.minValue)),
            maxText : String.format(this.parent.maxText, this.parent.formatDate(this.parent.maxValue))
        });
        this.menu.on("select",this.select,this);
        this.menu.on("show",this.show,this);
        this.menu.on("hide",this.hide,this);
        this.menu.picker.setValue(this.parent.getValue() || new Date());
        this.menu.show(this.parent.el, "tl-bl?");
    },
	
    select: function(m, d){  
		if (this.parent.getValue()) {
			var v = new Date(this.parent.getValue().getTime());
			m.picker.copyTimeField(d,v);
			this.parent.setValue(v);
		}  else {
			this.parent.setValue(d);
		}
    },
    show : function(){ 
    	this.parent.onFocus();
    },
    hide : function(){
    	this.parent.focus.defer(10, this.parent);
    	this.menu.un("select", this.select,  this);
    	this.menu.un("show", this.show,  this);
    	this.menu.un("hide", this.hide,  this);
    },
    destroy : function(){ 
    	if (this.menu) this.menu.destroy();
    },
	validateBlur : function(){
        return !this.menu || !this.menu.isVisible();
    }
});

util.widgets.TimeFieldMenu = function(config){
    util.widgets.TimeFieldMenu.superclass.constructor.call(this, config);
    this.plain = true;
    var di = new util.widgets.TimeFieldItem(config);
    this.add(di);
    
    this.picker = di.picker;
    
    this.relayEvents(di, ["select"]);

};
Ext.extend(util.widgets.TimeFieldMenu, Ext.menu.Menu, {
    cls:'x-timeField-menu',

    // private
    beforeDestroy : function() {
        this.picker.destroy();
    }
});

util.widgets.TimeFieldItem = function(config){
    util.widgets.TimeFieldItem.superclass.constructor.call(this, Ext.ComponentMgr.create(config,"timepicker"+config.timeField), config);
    
    
    this.picker = this.component;
    this.addEvents('select');
    
    this.picker.on("render", function(picker){
        picker.getEl().swallowEvent("click");
        picker.container.addClass("x-menu-timeField-item");
    });

    this.picker.on("select", this.onSelect, this);
};

Ext.extend(util.widgets.TimeFieldItem, util.widgets.Adapter, {
    // private
    onSelect : function(picker, date){
        this.fireEvent("select", this, date, picker);
        util.widgets.TimeFieldItem.superclass.handleClick.call(this);
    }
});


util.widgets.TimeFieldPicker = Ext.extend(Ext.Component, {
    
    minText : "This date is before the minimum date",
    
    maxText : "This date is after the maximum date",
    
    nowText : "Now",
    
    constrainToViewport : true,
    
    
    
    
    
    
    

    // private
    initComponent : function(){
        util.widgets.TimeFieldPicker.superclass.initComponent.call(this);

        var old = this.value;
        this.value = new Date();
        if (old) {
        	this.value.setTime(old.getTime());
        }
        
        this.addEvents(
            
            'select'
        );

        if(this.handler){
            this.on("select", this.handler,  this.scope || this);
        }

    },

    
    setMinDate : function(dt){
        this.minDate = dt;
        this.update(this.value, true);
    },
    
    
    setMaxDate : function(dt){
        this.maxDate = dt;
        this.update(this.value, true);
    },

    
    setValue : function(value){
        this.value = new Date();
        this.value.setTime(value.getTime());
        if(this.el){
            this.update(this.value,true);
        }
    },

    
    getValue : function(){
        return this.value;
    },

    // private
    focus : function(){
        if(this.el){
            this.update(this.activeDate);
        }
    },

    // private
    onRender : function(container, position){
        var m = [
             '<table cellspacing="0" width="'+this.columns*25+'">',
                '<tr><td class="x-date-middle" align="center">'+this.header+'</td></tr>',
                '<tr><td><table class="x-date-inner" cellspacing="0">'];
        
        m[m.length] = "<tbody><tr>";
        for(var i = 0; i < this.max; i++) {
            if(i % this.columns == 0 && i != 0){
                m[m.length] = "</tr><tr>";
            }
            var txt = (i<10) ? "0"+i : ""+i;
            m[m.length] = '<td><a href="#" hidefocus="on" class="x-date-date" tabIndex="1"><em><span>'+txt+'</span></em></a></td>';
        }
        m.push('</tr></tbody></table></td></tr>', 
                '</table><div class="x-date-mp"></div>');

        var el = document.createElement("div");
        el.className = "x-date-picker";
        el.innerHTML = this.generateContent();

        container.dom.insertBefore(el, position);

        this.el = Ext.get(el);
        this.eventEl = Ext.get(el.firstChild);

        this.eventEl.on("mousewheel", this.handleMouseWheel,  this);

        var kn = new Ext.KeyNav(this.eventEl, {
            "left" : function(e){
                this.update(this.activeDate.add(this.timeField, -1));
            },

            "right" : function(e){
                this.update(this.activeDate.add(this.timeField, 1));
            },

            "up" : function(e){
                this.update(this.activeDate.add(this.timeField, -this.columns));
            },

            "down" : function(e){
                this.update(this.activeDate.add(this.timeField, this.columns));
            },

            "enter" : function(e){
                e.stopPropagation();
                return true;
            },

            scope : this
        });

        this.eventEl.on("click", this.handleDateClick,  this, {delegate: "a.x-date-date"});

        this.el.unselectable();
        
        this.cells = this.el.select("table.x-date-inner tbody td");
        
        if(Ext.isIE){
            this.el.repaint();
        }
        this.update(this.value);
    },
    
    generateContent : function(e) {
    	var m = [
                 '<table cellspacing="0" width="'+this.columns*25+'">',
                    '<tr><td class="x-date-middle" align="center">'+this.header+'</td></tr>',
                    '<tr><td><table class="x-date-inner" cellspacing="0">'];
            
        m[m.length] = "<tbody><tr>";
        for(var i = 0; i < this.max; i++) {
            if(i % this.columns == 0 && i != 0){
                m[m.length] = "</tr><tr>";
            }
            var txt = (i<10) ? "0"+i : ""+i;
            m[m.length] = '<td><a href="#" hidefocus="on" class="x-date-date" tabIndex="1"><em><span>'+txt+'</span></em></a></td>';
        }
        m.push('</tr></tbody></table></td></tr>', 
                '</table><div class="x-date-mp"></div>');
       return m.join("");
    },

    // private
    handleMouseWheel : function(e){
        var delta = e.getWheelDelta();
        if(delta > 0){
        	this.update(this.activeDate.add(this.timeField, 1));
            e.stopEvent();
        } else if(delta < 0){
        	this.update(this.activeDate.add(this.timeField, -1));
            e.stopEvent();
        }
    },

    // private
    handleDateClick : function(e, t){
        e.stopEvent();
        if(t.timeFieldValue!=undefined && !Ext.fly(t.parentNode).hasClass("x-date-disabled")){
        	var v = new Date(this.activeDate.getTime());
        	this.updateTimeField(v,t.timeFieldValue);
        	this.setValue(v);
            this.fireEvent("select", this, this.value);
        }
    },

    // private
    update : function(date, forceRefresh){
        var vd = this.activeDate;
        this.activeDate = date;
        
        // 
        if(!forceRefresh && vd && this.el){
            var t = this.extractTimeField(date);
            this.cells.removeClass("x-date-selected");
            this.cells.each(function(c){
               if(c.dom.firstChild.timeFieldValue == t){
                   c.addClass("x-date-selected");
                   setTimeout(function(){
                        try{c.dom.firstChild.focus();}catch(e){}
                   }, 50);
                   return false;
               }
            });
            return;            
        }
        
        this.cells.removeClass("x-date-selected");
        var cells = this.cells.elements;
        var now = new Date();
        
        // convert everything to numbers so it's fast
        var min = this.minDate ? this.minTime(this.minDate).getTime() : Number.NEGATIVE_INFINITY;
        var max = this.maxDate ? this.maxTime(this.maxDate).getTime() : Number.POSITIVE_INFINITY;
        var d = new Date( date.getTime() );
        var tp = this;
        
        var setCellClass = function(cal, cell){
            cell.title = "";
            var t = d.getTime();
            var h = tp.extractTimeField(d);
            cell.firstChild.timeFieldValue = h;
            if(h == tp.extractTimeField(now)){
                cell.className += " x-date-today";
                cell.title = cal.nowText;
            }
            if(h == tp.extractTimeField(date)){
                cell.className += " x-date-selected";
                setTimeout(function(){
                    try{cell.firstChild.focus();}catch(e){}
                }, 50);
            }
            // disabling
            if(t < min) {
            	cell.className = " x-date-disabled";
                cell.title = cal.minText;
                return;
            }
            if(t > max) {
            	cell.className = " x-date-disabled";
                cell.title = cal.maxText;
                return;
            }            
        };

        for(var i=0; i < this.max; i++) {
        	this.updateTimeField(d,i);
        	cells[i].className = "x-date-active";
            setCellClass(this, cells[i]);
        }

        if(!this.internalRender){
            var main = this.el.dom.firstChild;
            var w = main.offsetWidth;
            this.el.setWidth(w + this.el.getBorderWidth("lr"));
            Ext.fly(main).setWidth(w);
            this.internalRender = true;
            // opera does not respect the auto grow header center column
            // then, after it gets a width opera refuses to recalculate
            // without a second pass
            if(Ext.isOpera && !this.secondPass){
                main.rows[0].cells[1].style.width = (w - (main.rows[0].cells[0].offsetWidth+main.rows[0].cells[2].offsetWidth)) + "px";
                this.secondPass = true;
                this.update.defer(10, this, [date]);
            }
        }
    },
    
    
    updateTimeField : Ext.emptyFn,
    
    
    extractTimeField : Ext.emptyFn,
    
    
    copyTimeField : function (sourceDate, targetDate) {
    	this.updateTimeField(targetDate,this.extractTimeField(sourceDate));
    },
    
    
    minTime : function(date) {
    	return new Date(Math.floor(date.getTime()/this.fieldInMillis)*this.fieldInMillis);
    },
    
    
    maxTime : function(date) {
    	return new Date((Math.floor(date.getTime()/this.fieldInMillis)+1)*this.fieldInMillis-1);
    }

    
});



util.widgets.DateHourPicker = Ext.extend(util.widgets.TimeFieldPicker, {	
	max:24,
	columns:6,
	timeField:'H',
	header:'Hours',
	fieldInMillis:1000*60*60,
	
	updateTimeField : function(date,timeFieldValue){
        date.setHours(timeFieldValue);
    },
    
    extractTimeField : function(date){
        return date.getHours();
    }
	
});

Ext.reg('timepickerH', util.widgets.DateHourPicker);

util.widgets.DateAMPMHourPicker = Ext.extend(util.widgets.DateHourPicker, {	
	timeField:'h',
	
	generateContent : function() {
		var m = [
             '<table cellspacing="0" width="'+this.columns*25+'">',
                '<tr><td class="x-date-middle" align="center">'+this.header+'</td></tr>'];
	
		m.push( this.generateXMContent('AM'));
		m.push( this.generateXMContent('PM'));
		m.push( '</table><div class="x-date-mp"></div>');
		return m.join("");
	},
	
	generateXMContent : function(xm) {
    	var m = ['<tr><td>',
                 '<table class="x-date-inner" cellspacing="0">',
                 '<th colspan="6"><span>'+xm+'</span></th>',
                 '<tbody><tr>'];
        for(var i = 0; i < 12; i++) {
            if(i % this.columns == 0 && i != 0){
                m[m.length] = "</tr><tr>";
            }
            var txt = (i<10) ? "0"+i : ""+i;
            m[m.length] = '<td><a href="#" hidefocus="on" class="x-date-date" tabIndex="1"><em><span>'+txt+'</span></em></a></td>';
        }
        m.push('</tr></tbody></table></td></tr>');
       return m.join("");
    }
	
});

Ext.reg('timepickerh', util.widgets.DateAMPMHourPicker);

util.widgets.DateMinutePicker = Ext.extend(util.widgets.TimeFieldPicker, {
	max:60,
	columns:10,
	timeField:'i',
	header:'Minutes',
	fieldInMillis:1000*60,
	
	updateTimeField : function(date,timeFieldValue){
        date.setMinutes(timeFieldValue);
    },
    
    extractTimeField : function(date){
        return date.getMinutes();
    }
	
});

Ext.reg('timepickeri', util.widgets.DateMinutePicker);

util.widgets.DateSecondPicker = Ext.extend(util.widgets.DateMinutePicker, {
	timeField:'s',
	header:'Seconds',
	fieldInMillis:1000,
	
	updateTimeField : function(date,timeFieldValue){
        date.setSeconds(timeFieldValue);
    },
    
    extractTimeField : function(date){
        return date.getSeconds();
    }
	
});
Ext.reg('timepickers', util.widgets.DateSecondPicker);
